# Generated by Django 2.2.13 on 2020-07-13 13:39

import common.models
from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion
import django.utils.timezone


class Migration(migrations.Migration):

    initial = True

    dependencies = [
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Subject',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('description', models.CharField(max_length=200, verbose_name='Descrição')),
                ('status', models.CharField(blank=True, choices=[('S', 'Ativo'), ('I', 'Inativo')], default='S', max_length=1, null=True, verbose_name='Status')),
            ],
            options={
                'verbose_name': 'Assunto',
            },
        ),
        migrations.CreateModel(
            name='Ticket',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', common.models.AutoCreatedAtField(blank=True, default=django.utils.timezone.now, null=True, verbose_name='Data de Criação')),
                ('modified_at', common.models.AutoModifiedAtField(blank=True, default=django.utils.timezone.now, null=True, verbose_name='Última Modificação')),
                ('description', models.TextField(help_text='Descreva o assunto', verbose_name='Descricao')),
                ('status', models.CharField(blank=True, choices=[('A', 'Aberto'), ('R', 'Respondido'), ('T', 'Retornado'), ('X', 'Encerrado')], default='A', max_length=1, null=True, verbose_name='Status')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='helpdesk_ticket_created_by', to=settings.AUTH_USER_MODEL, verbose_name='Cadastrado Por')),
                ('modified_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='helpdesk_ticket_modified_by', to=settings.AUTH_USER_MODEL, verbose_name='Modificado Por')),
                ('subject', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='tickets', to='helpdesk.Subject', verbose_name='Assunto')),
            ],
            options={
                'verbose_name': 'Ticket',
            },
            bases=(common.models.CommonAbsoluteUrlMixin, models.Model),
        ),
        migrations.CreateModel(
            name='FollowUp',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('created_at', common.models.AutoCreatedAtField(blank=True, default=django.utils.timezone.now, null=True, verbose_name='Data de Criação')),
                ('modified_at', common.models.AutoModifiedAtField(blank=True, default=django.utils.timezone.now, null=True, verbose_name='Última Modificação')),
                ('followup', models.TextField(verbose_name='Andamento')),
                ('status', models.CharField(blank=True, choices=[('A', 'Aberto'), ('R', 'Respondido'), ('T', 'Retornado'), ('X', 'Encerrado')], default='A', max_length=1, null=True, verbose_name='Status')),
                ('created_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='helpdesk_followup_created_by', to=settings.AUTH_USER_MODEL, verbose_name='Cadastrado Por')),
                ('modified_by', models.ForeignKey(blank=True, null=True, on_delete=django.db.models.deletion.PROTECT, related_name='helpdesk_followup_modified_by', to=settings.AUTH_USER_MODEL, verbose_name='Modificado Por')),
                ('ticket', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='followups', to='helpdesk.Ticket', verbose_name='Ticket')),
            ],
            options={
                'verbose_name': 'Andamento',
            },
            bases=(common.models.CommonAbsoluteUrlMixin, models.Model),
        ),
    ]
